/*
 *			Copyright  John Wainwright 1988
 */
 
#include <stdio.h>
#include "memoryMgr.h"

char *
salloc(n)
	int	n;
{
	register Handle p;

	p = NewHandle((long)n);
	HLock(p);
	if (MemErr == 0)
		return *p;
	fprintf(stderr, "Ran out of memory.\n");
}

char *
scalloc(n)
	register int	n;
{
	register Handle p;
	register char 	*q;

	p = NewHandle((long)n);
	if (MemErr == 0)
	{
		HLock(p);
		for (q = *p; n--;)
			*q++ = 0;
		return *p;
	}
	fprintf(stderr, "Ran out of memory.\n");
}

char *
srealloc(p, n)
	char	*p;
	int		n;
{
	register long 	i;
	register char	*q, *qq;
	register Handle	ph;
	
	q = qq = salloc((long)n);
	ph = RecoverHandle(p);
	for (i = GetHandleSize(ph); i--; )
		*qq++ = *p++;
	DisposHandle(ph);
	return	q;
}

int
free(p)
	char *p;
{
	DisposHandle(RecoverHandle(p));
}